Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/physiq.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/physiq.F	(revision 3)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/physiq.F	(revision 300)
@@ -1196,56 +1471,191 @@
 C
          CALL histdef(nid_ins, "phis", "Surface geop. height", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
      .                "once", zsto,zout)
 c
          CALL histdef(nid_ins, "aire", "Grid area", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
      .                "once", zsto,zout)
 c
 c Champs 2D:
 c
-         CALL histdef(nid_ins, "psol", "Surface Pressure", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+        CALL histdef(nid_ins, "tsol", "Surface Temperature", "K",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "inst(X)", zsto,zout)
 c
+        CALL histdef(nid_ins, "psol", "Surface Pressure", "Pa",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "plul", "Large-scale Precip.", "mm/day",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "pluc", "Convective Precip.", "mm/day",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
+     .                "inst(X)", zsto,zout)
+
+        CALL histdef(nid_ins, "qsol", "Surface humidity", "mm",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "rain", "Precipitation", "mm/day",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "snow", "Snow fall", "mm/day",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "snow_cov", "Snow cover", "mm",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
          CALL histdef(nid_ins, "topl", "OLR", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
      .                "inst(X)", zsto,zout)
 c
+         CALL histdef(nid_ins, "evap", "Evaporation", "mm/day",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "sols", "Solar rad. at surf.", "W/m2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "soll", "IR rad. at surface", "W/m2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "solldown", "Down. IR rad. at surface", 
+     .                "W/m2", iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "bils", "Surf. total heat flux", "W/m2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "sens", "Sensible heat flux", "W/m2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "fder", "Heat flux derivation", "W/m2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+      CALL histdef(nid_ins, "dtsvdfo", "Boundary-layer dTs(o)", "K/s",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+      CALL histdef(nid_ins, "dtsvdft", "Boundary-layer dTs(t)", "K/s",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+      CALL histdef(nid_ins, "dtsvdfg", "Boundary-layer dTs(g)", "K/s",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+      CALL histdef(nid_ins, "dtsvdfi", "Boundary-layer dTs(g)", "K/s",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+
+         DO nsrf = 1, nbsrf
+C
+           call histdef(nid_ins, "pourc_"//clnsurf(nsrf), 
+     $         "Fraction"//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+
+           call histdef(nid_ins, "sens_"//clnsurf(nsrf), 
+     $         "Sensible heat flux "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+c
+           call histdef(nid_ins, "tsol_"//clnsurf(nsrf), 
+     $         "Surface Temperature"//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+c
+           call histdef(nid_ins, "lat_"//clnsurf(nsrf), 
+     $         "Latent heat flux "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+C
+           call histdef(nid_ins, "taux_"//clnsurf(nsrf), 
+     $         "Zonal wind stress"//clnsurf(nsrf),"Pa",
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+
+           call histdef(nid_ins, "tauy_"//clnsurf(nsrf), 
+     $         "Meridional xind stress "//clnsurf(nsrf), "Pa",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+c
+           call histdef(nid_ins, "albe_"//clnsurf(nsrf), 
+     $         "Albedo "//clnsurf(nsrf), "-",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+c
+           call histdef(nid_ins, "rugs_"//clnsurf(nsrf), 
+     $         "rugosite "//clnsurf(nsrf), "-",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "inst(X)", zsto,zout)
+C§§§
+         END DO 
+         CALL histdef(nid_ins, "rugs", "rugosity", "-",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+
+c
+         CALL histdef(nid_ins, "albs", "Surface albedo", "-",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+         CALL histdef(nid_ins, "albslw", "Surface albedo LW", "-",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "inst(X)", zsto,zout)
+c
+c
 c Champs 3D:
 c
          CALL histdef(nid_ins, "temp", "Temperature", "K",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
 c
          CALL histdef(nid_ins, "vitu", "Zonal wind", "m/s",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
 c
          CALL histdef(nid_ins, "vitv", "Merid wind", "m/s",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
 c
          CALL histdef(nid_ins, "geop", "Geopotential height", "m",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
 c
          CALL histdef(nid_ins, "pres", "Air pressure", "Pa",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
 c
+         CALL histdef(nid_ins, "dtvdf", "Boundary-layer dT", "K/s",
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
+     .                "inst(X)", zsto,zout)
+c
+         CALL histdef(nid_ins, "dqvdf", "Boundary-layer dQ", "Kg/Kg/s",
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
+     .                "inst(X)", zsto,zout)
+c
+
          CALL histend(nid_ins)
 c
-         ndex(1) = 0
-c
-         i = NINT(zout/zsto)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
-         CALL histwrite(nid_ins,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex)
-c
-         i = NINT(zout/zsto)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
-         CALL histwrite(nid_ins,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex)
+         ndex2d = 0
+         ndex3d = 0
 c
       ENDIF
+
+c$$$PB Positionner date0 pour initialisation de ORCHIDEE
+c$$$      date0 = zjulian
+      date0 = day_ini
+      WRITE(*,*) 'physiq date0 : ',date0
 c
 c
@@ -1260,19 +1670,4 @@
 cc         ENDDO
 c
-         IF (ok_oasis) THEN
-         DO i = 1, klon
-           oas_sols(i) = 0.0
-           oas_nsol(i) = 0.0
-           oas_rain(i) = 0.0
-           oas_snow(i) = 0.0
-           oas_evap(i) = 0.0
-           oas_ruis(i) = 0.0
-           oas_tsol(i) = 0.0
-           oas_fder(i) = 0.0
-           oas_albe(i) = 0.0
-           oas_taux(i) = 0.0
-           oas_tauy(i) = 0.0
-         ENDDO
-         ENDIF
 c
       ENDIF
@@ -1328,4 +1723,23 @@
       ENDIF
 c
+c Diagnostiquer la tendance dynamique
+c
+      IF (ancien_ok) THEN
+         DO k = 1, klev
+         DO i = 1, klon
+            d_t_dyn(i,k) = (t_seri(i,k)-t_ancien(i,k))/dtime
+            d_q_dyn(i,k) = (q_seri(i,k)-q_ancien(i,k))/dtime
+         ENDDO
+         ENDDO
+      ELSE
+         DO k = 1, klev
+         DO i = 1, klon
+            d_t_dyn(i,k) = 0.0
+            d_q_dyn(i,k) = 0.0
+         ENDDO
+         ENDDO
+         ancien_ok = .TRUE.
+      ENDIF
+c
 c Ajouter le geopotentiel du sol:
 c
@@ -1338,5 +1752,4 @@
 c Verifier les temperatures
 c
-
       CALL hgardfou(t_seri,ftsol,'debutphy')
 c
@@ -1352,20 +1765,5 @@
          idayvrai = NINT(xjour)
          PRINT *,' PHYS cond  julien ',julien,idayvrai
-         CALL condsurf(julien,idayvrai, pctsrf ,
-     .                  lmt_sst,lmt_alb,lmt_rug,lmt_bils  )
          CALL ozonecm( FLOAT(julien), rlat, paprs, wo)
-      ENDIF
-c
- 
-      IF (ok_ocean) THEN
-         DO i = 1, klon
-            ftsol(i,is_oce) = lmt_sst(i) + deltat(i)
-         ENDDO
-
-      ELSE
-         DO i = 1, klon
-            ftsol(i,is_oce) = lmt_sst(i)
-         ENDDO
-
       ENDIF
 c
@@ -1391,8 +1789,10 @@
 c
       DO i = 1, klon
-         frugs(i,is_ter) = SQRT(lmt_rug(i)**2+rugoro(i)**2)
-         frugs(i,is_lic) = rugoro(i)
-         frugs(i,is_oce) = rugmer(i)
-         frugs(i,is_sic) = 0.001
+c       if (.not. ok_veget) then
+c          frugs(i,is_ter) = SQRT(frugs(i,is_ter)**2+rugoro(i)**2)
+c       endif 
+c         frugs(i,is_lic) = rugoro(i)
+c         frugs(i,is_oce) = rugmer(i)
+c         frugs(i,is_sic) = 0.001
          zxrugs(i) = 0.0
       ENDDO
@@ -1404,23 +1804,65 @@
       DO nsrf = 1, nbsrf
       DO i = 1, klon
-         zxrugs(i) = zxrugs(i) + frugs(i,nsrf)*pctsrf(i,nsrf)
-      ENDDO
-      ENDDO
-c
-      CALL clmain(dtime,pctsrf,
-     e            t_seri,q_seri,u_seri,v_seri,soil_model,
-     e            ftsol,soilcap,soilflux,paprs,pplay,radsol,
-     e            fsnow,fqsol,
-     e            rlat, frugs,
+            zxrugs(i) = zxrugs(i) + frugs(i,nsrf)*pctsrf(i,nsrf)
+      ENDDO
+      ENDDO
+c
+C calculs necessaires au calcul de l'albedo dans l'interface
+c
+      CALL orbite(FLOAT(julien),zlongi,dist)
+      IF (cycle_diurne) THEN
+        zdtime=dtime*FLOAT(radpas) ! pas de temps du rayonnement (s)
+        CALL zenang(zlongi,gmtime,zdtime,rlat,rlon,rmu0,fract)
+      ELSE
+        rmu0 = -999.999
+      ENDIF
+
+      fder = dlw
+
+      CALL clmain(dtime,itap,zjulian,pctsrf,
+     e            t_seri,q_seri,u_seri,v_seri,
+     e            julien, rmu0, 
+     e            ok_veget, ocean, npas, nexca, ftsol,
+     $            soil_model,ftsoil,
+     $            paprs,pplay,radsol, fsnow,fqsol,fevap,falbe,falblw,
+     $            fluxlat,
+     e            rain_fall, snow_fall, solsw, sollw, sollwdown, fder,
+     e            rlon, rlat, cufi, cvfi, frugs,
+     e            debut, lafin, agesno,rugoro ,
      s            d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_ts,
-     s            fluxt,fluxq,fluxu,fluxv,cdragh,cdragm,rugmer,
+     s            fluxt,fluxq,fluxu,fluxv,cdragh,cdragm,
      s            dsens, devap,
      s            ycoefh,yu1,yv1) 
-c
-      DO i = 1, klon
-         sens(i) = - fluxt(i,1) ! flux de chaleur sensible au sol
-         evap(i) = - fluxq(i,1) ! flux d'evaporation au sol
-         fder(i) = dsens(i) + devap(i)
-      ENDDO
+
+c
+C§§§ PB
+C§§§ Incrementation des flux
+C§§
+      zxfluxt=0.
+      zxfluxq=0.
+      zxfluxu=0.
+      zxfluxv=0.
+      DO nsrf = 1, nbsrf
+        DO k = 1, klev
+          DO i = 1, klon
+            zxfluxt(i,k) = zxfluxt(i,k) + 
+     $          fluxt(i,k,nsrf) * pctsrf( i, nsrf)
+            zxfluxq(i,k) = zxfluxq(i,k) + 
+     $          fluxq(i,k,nsrf) * pctsrf( i, nsrf)
+            zxfluxu(i,k) = zxfluxu(i,k) + 
+     $          fluxu(i,k,nsrf) * pctsrf( i, nsrf)
+            zxfluxv(i,k) = zxfluxv(i,k) + 
+     $          fluxv(i,k,nsrf) * pctsrf( i, nsrf)
+          END DO 
+        END DO 
+      END DO 
+      DO i = 1, klon
+         sens(i) = - zxfluxt(i,1) ! flux de chaleur sensible au sol
+c         evap(i) = - fluxq(i,1) ! flux d'evaporation au sol
+         evap(i) = - zxfluxq(i,1) ! flux d'evaporation au sol
+         fder(i) = dlw(i) + dsens(i) + devap(i)
+      ENDDO
+
+
       DO k = 1, klev
       DO i = 1, klon
@@ -1436,9 +1878,17 @@
       DO i = 1, klon
          zxtsol(i) = 0.0
+         IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
+     $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
+     $       THEN 
+             WRITE(*,*) 'physiq : pb sous surface au point ', i, 
+     $           pctsrf(i, 1 : nbsrf)
+         ENDIF 
       ENDDO
       DO nsrf = 1, nbsrf
       DO i = 1, klon
-         ftsol(i,nsrf) = ftsol(i,nsrf) + d_ts(i,nsrf)
-         zxtsol(i) = zxtsol(i) + ftsol(i,nsrf)*pctsrf(i,nsrf)
+c$$$        IF (pctsrf(i,nsrf) .GE. EPSFRA) THEN 
+            ftsol(i,nsrf) = ftsol(i,nsrf) + d_ts(i,nsrf)
+            zxtsol(i) = zxtsol(i) + ftsol(i,nsrf)*pctsrf(i,nsrf)
+c$$$        ENDIF 
       ENDDO
       ENDDO
@@ -1448,28 +1898,20 @@
 c
       DO nsrf = 1, nbsrf
-      DO i = 1, klon
-         IF (pctsrf(i,nsrf).LT.epsfra) ftsol(i,nsrf) = zxtsol(i)
-      ENDDO
-      ENDDO
-
-c
-c Appeler le modele du sol
-c
-      IF (soil_model) THEN
-         DO nsrf = 1, nbsrf
-         CALL soil(dtime, nsrf, fsnow(1,nsrf),
-     .             ftsol(1,nsrf), ftsoil(1,1,nsrf),
-     .             soilcap(1,nsrf), soilflux(1,nsrf))
-         ENDDO
-      ENDIF
+        DO i = 1, klon
+          IF (pctsrf(i,nsrf) .LT. epsfra) ftsol(i,nsrf) = zxtsol(i)
+        ENDDO
+      ENDDO
+
 c
 c Calculer la derive du flux infrarouge
 c
-      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-         fder(i) = fder(i) - 4.0*RSIGMA*zxtsol(i)**3 *
-     .                       (ftsol(i,nsrf)-zxtsol(i))
-     .                      *pctsrf(i,nsrf)
-      ENDDO
+c$$$      DO nsrf = 1, nbsrf
+      DO i = 1, klon
+c$$$        IF (pctsrf(i,nsrf) .GE. EPSFRA) THEN 
+            dlw(i) = - 4.0*RSIGMA*zxtsol(i)**3 
+c$$$     .          *(ftsol(i,nsrf)-zxtsol(i))
+c$$$     .          *pctsrf(i,nsrf)
+c$$$        ENDIF 
+c$$$      ENDDO
       ENDDO
 c
@@ -1478,5 +1920,5 @@
       DO k = 1, klev
       DO i = 1, klon
-         conv_q(i,k) = d_qx_dyn(i,k,ivap) 
+         conv_q(i,k) = d_q_dyn(i,k) 
      .               + d_q_vdf(i,k)/dtime
          conv_t(i,k) = d_t_dyn(i,k) 
@@ -1485,5 +1927,19 @@
       ENDDO
       IF (check) THEN
-         CALL qcheck(klon,klev,paprs,q_seri,ql_seri,"avantcon=")
+         za = qcheck(klon,klev,paprs,q_seri,ql_seri,paire)
+         PRINT*, "avantcon=", za
+      ENDIF
+      zx_ajustq = .FALSE.
+      IF (iflag_con.EQ.2) zx_ajustq=.TRUE.
+      IF (zx_ajustq) THEN
+         DO i = 1, klon
+            z_avant(i) = 0.0
+         ENDDO
+         DO k = 1, klev
+         DO i = 1, klon
+            z_avant(i) = z_avant(i) + (q_seri(i,k)+ql_seri(i,k))
+     .                        *(paprs(i,k)-paprs(i,k+1))/RG
+         ENDDO
+         ENDDO
       ENDIF
       IF (iflag_con.EQ.1) THEN
@@ -1494,8 +1950,10 @@
       ELSE IF (iflag_con.EQ.2) THEN
       CALL conflx(dtime, paprs, pplay, t_seri, q_seri,
-     e            conv_t, conv_q, fluxq(1,1), omega,
+     e            conv_t, conv_q, zxfluxq(1,1), omega,
      s            d_t_con, d_q_con, rain_con, snow_con,
      s            pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      s            kcbot, kctop, kdtop, pmflxr, pmflxs)
+      WHERE (rain_con < 0.) rain_con = 0.
+      WHERE (snow_con < 0.) snow_con = 0.
       DO i = 1, klon
          ibas_con(i) = klev+1 - kcbot(i)
@@ -1507,35 +1965,118 @@
 c    s             d_t_con, d_q_con, 
 c    s             rain_con, snow_con, ibas_con, itop_con)
+cKE43
+      ELSE IF (iflag_con.EQ.4) THEN
+c nb of tracers for the KE convection:
+          if (nqmax .GE. 4) then
+              ntra = nbtr
+          else
+              ntra = 1 
+          endif
+cke43 (arguments inutiles enleves => des SAVE dans conema43?)
+c$$$          CALL conema43(dtime,paprs,pplay,t_seri,q_seri,
+c$$$     $        u_seri,v_seri,tr_seri,nbtr,
+c$$$     .        ema_workcbmf,
+c$$$     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
+c$$$     .        wdn, tdn, qdn,
+c$$$     .        rain_con, snow_con, ibas_con, itop_con,
+c$$$     .        upwd,dnwd,dnwd0,bas,top,Ma,cape,tvp,rflag,
+c$$$     .        pbase
+c$$$     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,
+c$$$     .        pori_con,plcl_con,dtma_con,dtlcl_con)
+          if (0.eq.1) then ! vectorise
+          CALL conemav (dtime,paprs,pplay,t_seri,q_seri,
+     .        u_seri,v_seri,tr_seri,nbtr,
+     .        ema_work1,ema_work2,
+     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
+     .        rain_con, snow_con, ibas_con, itop_con,
+     .        upwd,dnwd,dnwd0,
+c    .        Ma,cape,tvp,(/(nint(rflag(i)),i=1,size(rflag))/),
+     .        Ma,cape,tvp,iflagctrl,
+     .       pbase
+     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr)
+
+          else
+
+          CALL conema (dtime,paprs,pplay,t_seri,q_seri,
+     $        u_seri,v_seri,tr_seri,nbtr,
+     .        ema_work1,ema_work2,
+     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
+c$$$     .        wdn, tdn, qdn,
+     .        rain_con, snow_con, ibas_con, itop_con,
+     .        upwd,dnwd,dnwd0,bas,top,Ma,cape,tvp,rflag,
+     .        pbase
+     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr)
+c$$$     .        pori_con,plcl_con,dtma_con,dtlcl_con)
+          endif
+          DO i = 1, klon
+            ema_pcb(i)  = pbase(i)
+          ENDDO
+          DO i = 1, klon
+            ema_pct(i)  = paprs(i,itop_con(i))
+          ENDDO
+          DO i = 1, klon
+            ema_cbmf(i) = ema_workcbmf(i)
+          ENDDO      
       ELSE
-      PRINT*, "iflag_con non-prevu", iflag_con
-      CALL abort
+          PRINT*, "iflag_con non-prevu", iflag_con
+          CALL abort
       ENDIF
+
       CALL homogene(paprs, q_seri, d_q_con, u_seri,v_seri,
      .              d_u_con, d_v_con)
       DO k = 1, klev
-      DO i = 1, klon
+        DO i = 1, klon
          t_seri(i,k) = t_seri(i,k) + d_t_con(i,k)
          q_seri(i,k) = q_seri(i,k) + d_q_con(i,k)
          u_seri(i,k) = u_seri(i,k) + d_u_con(i,k)
          v_seri(i,k) = v_seri(i,k) + d_v_con(i,k)
-      ENDDO
+        ENDDO
       ENDDO
       IF (check) THEN
-         CALL qcheck(klon,klev,paprs,q_seri,ql_seri,"aprescon=")
-         zx_t = 0.0
-         DO i = 1, klon
-            zx_t = zx_t + rain_con(i)+snow_con(i)
-         ENDDO
-         zx_t = zx_t/FLOAT(klon)*dtime
-         PRINT*, "Precip=", zx_t
+          za = qcheck(klon,klev,paprs,q_seri,ql_seri,paire)
+          PRINT*, "aprescon=", za
+          zx_t = 0.0
+          za = 0.0
+          DO i = 1, klon
+            za = za + paire(i)/FLOAT(klon)
+            zx_t = zx_t + (rain_con(i)+snow_con(i))*paire(i)/FLOAT(klon)
+          ENDDO
+          zx_t = zx_t/za*dtime
+          PRINT*, "Precip=", zx_t
       ENDIF
+      IF (zx_ajustq) THEN
+          DO i = 1, klon
+            z_apres(i) = 0.0
+          ENDDO
+          DO k = 1, klev
+            DO i = 1, klon
+              z_apres(i) = z_apres(i) + (q_seri(i,k)+ql_seri(i,k))
+     .            *(paprs(i,k)-paprs(i,k+1))/RG
+            ENDDO
+          ENDDO
+          DO i = 1, klon
+            z_factor(i) = (z_avant(i)-(rain_con(i)+snow_con(i))*dtime)
+     .          /z_apres(i)
+          ENDDO
+          DO k = 1, klev
+            DO i = 1, klon
+              IF (z_factor(i).GT.(1.0+1.0E-08) .OR.
+     .            z_factor(i).LT.(1.0-1.0E-08)) THEN
+                  q_seri(i,k) = q_seri(i,k) * z_factor(i)
+              ENDIF
+            ENDDO
+          ENDDO
+      ENDIF
+      zx_ajustq=.FALSE.
 c
       IF (nqmax.GT.2) THEN !--melange convectif de traceurs
 c
-      IF (iflag_con.NE.2) THEN
-         PRINT*, "Pour l instant, seul conflx fonctionne avec traceurs"
-         PRINT*,' Mettre iflag_con = 2  dans  run.def et repasser  !'
-         CALL abort
-      ENDIF
+          IF (iflag_con .NE. 2 .AND.  iflag_con .NE. 4 ) THEN 
+              PRINT*, 'Pour l instant, seul conflx fonctionne ',
+     $            'avec traceurs', iflag_con
+              PRINT*,' Mettre iflag_con', 
+     $            ' = 2  ou 4 dans run.def et repasser'
+              CALL abort
+              ENDIF 
 c
       ENDIF !--nqmax.GT.2
@@ -1543,5 +2084,16 @@
 c Appeler l'ajustement sec
 c
-C appel supprime pour le moment
+      CALL ajsec(paprs, pplay, t_seri, q_seri, d_t_ajs, d_q_ajs)
+      DO k = 1, klev
+      DO i = 1, klon
+         t_seri(i,k) = t_seri(i,k) + d_t_ajs(i,k)
+         q_seri(i,k) = q_seri(i,k) + d_q_ajs(i,k)
+      ENDDO
+      ENDDO
+
+c   RATQS
+      call calcratqs (
+     I            paprs,pplay,q_seri,d_t_con,d_t_ajs
+     O           ,ratqs,zpt_conv)
 c
 c Appeler le processus de condensation a grande echelle
@@ -1549,9 +2101,12 @@
 c
       CALL fisrtilp_tr(dtime,paprs,pplay,
-     .           t_seri, q_seri,
+     .           t_seri, q_seri,ratqs,
      .           d_t_lsc, d_q_lsc, d_ql_lsc, rneb, cldliq,
      .           rain_lsc, snow_lsc,
      .           pfrac_impa, pfrac_nucl, pfrac_1nucl,
-     .           frac_impa, frac_nucl )
+     .           frac_impa, frac_nucl,
+     .           prfl, psfl)
+      WHERE (rain_lsc < 0) rain_lsc = 0.
+      WHERE (snow_lsc < 0) snow_lsc = 0.
       DO k = 1, klev
       DO i = 1, klon
@@ -1564,10 +2119,13 @@
       ENDDO
       IF (check) THEN
-         CALL qcheck(klon,klev,paprs,q_seri,ql_seri,"apresilp=")
+         za = qcheck(klon,klev,paprs,q_seri,ql_seri,paire)
+         PRINT*, "apresilp=", za
          zx_t = 0.0
+         za = 0.0
          DO i = 1, klon
-            zx_t = zx_t + rain_lsc(i)+snow_lsc(i)
-         ENDDO
-         zx_t = zx_t/FLOAT(klon)*dtime
+            za = za + paire(i)/FLOAT(klon)
+            zx_t = zx_t + (rain_lsc(i)+snow_lsc(i))*paire(i)/FLOAT(klon)
+        ENDDO
+         zx_t = zx_t/za*dtime
          PRINT*, "Precip=", zx_t
       ENDIF
@@ -1576,7 +2134,21 @@
 c
       IF (iflag_con.EQ.2) THEN ! seulement pour Tiedtke
-      CALL diagcld(paprs,pplay,t_seri,q_seri,
+      CALL diagcld1(paprs,pplay,
      .             rain_con,snow_con,ibas_con,itop_con,
      .             diafra,dialiq)
+      DO k = 1, klev
+      DO i = 1, klon
+      IF (diafra(i,k).GT.cldfra(i,k)) THEN
+         cldliq(i,k) = dialiq(i,k)
+         cldfra(i,k) = diafra(i,k)
+      ENDIF
+      ENDDO
+      ENDDO
+      ENDIF
+c
+c Nuages stratus artificiels:
+c
+      IF (ok_stratus) THEN
+      CALL diagcld2(paprs,pplay,t_seri,q_seri, diafra,dialiq)
       DO k = 1, klev
       DO i = 1, klon
@@ -1628,36 +2200,28 @@
 c
       IF (MOD(itaprad,radpas).EQ.0) THEN
-      CALL orbite(FLOAT(julien),zlongi,dist)
-      IF (cycle_diurne) THEN
-        zdtime=dtime*FLOAT(radpas) ! pas de temps du rayonnement (s)
-        CALL zenang(zlongi,gmtime,zdtime,rlat,rlon,rmu0,fract)
-c        CALL zenith(zlongi,gmtime,rlat,rlon,rmu0,fract) !va disparaitre
-        CALL alboc_cd(rmu0,alb_eau)
-      ELSE
-        CALL angle(zlongi,rlat,fract,rmu0)
-        CALL alboc(FLOAT(julien),rlat,alb_eau)
-      ENDIF
-      CALL albsno(veget,agesno,alb_neig)
-      DO i = 1, klon
-         zx_alb_oce = alb_eau(i)
-         IF (pctsrf(i,is_oce).GT.epsfra .AND. ftsol(i,is_oce).LT.271.35)
-     .   zx_alb_oce = 0.6 ! pour slab_ocean
-         zfra = MAX(0.0,MIN(1.0,fsnow(i,is_lic)/(fsnow(i,is_lic)+10.0)))
-         zx_alb_lic = alb_neig(i)*zfra + 0.6*(1.0-zfra)
-         zfra = MAX(0.0,MIN(1.0,fsnow(i,is_ter)/(fsnow(i,is_ter)+10.0)))
-         zx_alb_ter = alb_neig(i)*zfra + lmt_alb(i)*(1.0-zfra)
-         zfra = MAX(0.0,MIN(1.0,fsnow(i,is_sic)/(fsnow(i,is_sic)+10.0)))
-         zx_alb_sic = alb_neig(i)*zfra + 0.6*(1.0-zfra)
-         albsol(i) = zx_alb_oce * pctsrf(i,is_oce)
-     .             + zx_alb_lic * pctsrf(i,is_lic)
-     .             + zx_alb_ter * pctsrf(i,is_ter)
-     .             + zx_alb_sic * pctsrf(i,is_sic)
-      ENDDO
+      DO i = 1, klon
+         albsol(i) = falbe(i,is_oce) * pctsrf(i,is_oce)
+     .             + falbe(i,is_lic) * pctsrf(i,is_lic)
+     .             + falbe(i,is_ter) * pctsrf(i,is_ter)
+     .             + falbe(i,is_sic) * pctsrf(i,is_sic)
+         albsollw(i) = falblw(i,is_oce) * pctsrf(i,is_oce)
+     .               + falblw(i,is_lic) * pctsrf(i,is_lic)
+     .               + falblw(i,is_ter) * pctsrf(i,is_ter)
+     .               + falblw(i,is_sic) * pctsrf(i,is_sic)
+      ENDDO
+!      if (debut) then
+!        albsol1 = albsol
+!        albsollw1 = albsollw
+!      endif
+!      albsol = albsol1
+!      albsollw = albsollw1
       CALL radlwsw ! nouveau rayonnement (compatible Arpege-IFS)
      e            (dist, rmu0, fract, co2_ppm, solaire,
-     e             paprs, pplay,zxtsol,albsol, t_seri,q_seri,wo,
+     e             paprs, pplay,zxtsol,albsol, albsollw, t_seri,q_seri,
+     e             wo,
      e             cldfra, cldemi, cldtau,
      s             heat,heat0,cool,cool0,radsol,albpla,
      s             topsw,toplw,solsw,sollw,
+     s             sollwdown,
      s             topsw0,toplw0,solsw0,sollw0)
       itaprad = 0
@@ -1676,6 +2240,6 @@
 c Calculer l'hydrologie de la surface
 c
-      CALL hydrol(dtime,pctsrf,rain_fall, snow_fall, evap,
-     .            agesno, ftsol,fqsol,fsnow, ruis)
+c      CALL hydrol(dtime,pctsrf,rain_fall, snow_fall, zxevap,
+c     .            agesno, ftsol,fqsol,fsnow, ruis)
 c
       DO i = 1, klon
@@ -1692,12 +2256,12 @@
 c Si une sous-fraction n'existe pas, elle prend la valeur moyenne
 c
-      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-         IF (pctsrf(i,nsrf).LT.epsfra) THEN
-            fqsol(i,nsrf) = zxqsol(i)
-            fsnow(i,nsrf) = zxsnow(i)
-         ENDIF
-      ENDDO
-      ENDDO
+c$$$      DO nsrf = 1, nbsrf
+c$$$      DO i = 1, klon
+c$$$         IF (pctsrf(i,nsrf).LT.epsfra) THEN
+c$$$            fqsol(i,nsrf) = zxqsol(i)
+c$$$            fsnow(i,nsrf) = zxsnow(i)
+c$$$         ENDIF
+c$$$      ENDDO
+c$$$      ENDDO
 c
 c Calculer le bilan du sol et la derive de temperature (couplage)
@@ -1706,14 +2270,4 @@
          bils(i) = radsol(i) - sens(i) - evap(i)*RLVTT
       ENDDO
-      IF (ok_ocean) THEN
-         DO i = 1, klon
-            cthermiq = cyang
-            IF (ftsol(i,is_oce).LT. 271.35) cthermiq = cbing
-            IF (pctsrf(i,is_oce).GT.epsfra) deltat(i) = deltat(i) +
-     .                          (bils(i)-lmt_bils(i))/cthermiq * dtime
-            IF (deltat(i).GT.15.0 ) deltat(i) = 15.0
-            IF (deltat(i).LT.-15.0) deltat(i) = -15.0
-         ENDDO
-      ENDIF
 c
 cmoddeblott(jan95)
@@ -1734,9 +2288,9 @@
         ENDIF
         ENDDO
-        igwdim=MAX(1,igwd)
+c        igwdim=MAX(1,igwd)
 c
         CALL drag_noro(klon,klev,dtime,paprs,pplay,
      e                   zmea,zstd, zsig, zgam, zthe,zpic,zval,
-     e                   igwd,igwdim,idx,itest,
+     e                   igwd,idx,itest,
      e                   t_seri, u_seri, v_seri,
      s                   zulow, zvlow, zustr, zvstr,
@@ -1766,9 +2320,9 @@
         ENDIF
         ENDDO
-        igwdim=MAX(1,igwd)
+c        igwdim=MAX(1,igwd)
 c
         CALL lift_noro(klon,klev,dtime,paprs,pplay,
-     e                   rlat,zmea,zstd, zsig, zgam, zthe,zpic,zval,
-     e                   igwd,igwdim,idx,itest,
+     e                   rlat,zmea,zstd,zpic,
+     e                   itest,
      e                   t_seri, u_seri, v_seri,
      s                   zulow, zvlow, zustr, zvstr,
@@ -1792,9 +2346,27 @@
 c   Calcul  des tendances traceurs
 c====================================================================
+C Pascale : il faut quand meme apeller phytrac car il gere les sorties
+cKE43       des traceurs => il faut donc mettre des flags a .false.
+      IF (iflag_con.EQ.4) THEN
+c           on ajoute les tendances calculees par KE43
+c$$$ OM on onhibe la convection sur les traceurs
+        DO iq=1, nqmax-2 ! Sandrine a -3 ???
+c$$$ OM on inhibe la convection sur les traceur
+c$$$        DO k = 1, nlev
+c$$$        DO i = 1, klon
+c$$$          tr_seri(i,k,iq) = tr_seri(i,k,iq) + d_tr(i,k,iq)
+c$$$        ENDDO
+c$$$        ENDDO
+        WRITE(iqn,'(i2.2)') iq
+        CALL minmaxqfi(tr_seri(1,1,iq),0.,1.e33,'couche lim iq='//iqn)
+        ENDDO
 CMAF modif pour garder info du nombre de traceurs auxquels
 C la physique s'applique
+      ELSE
+CMAF modif pour garder info du nombre de traceurs auxquels
+C la physique s'applique
 C
       call phytrac (rnpb,
-     I                   debut,
+     I                   debut,lafin,
      I                   nqmax-2,
      I                   nlon,nlev,dtime,
@@ -1805,11 +2377,15 @@
      I                   rlon,presnivs,paire,pphis,
      O                   tr_seri)
+      ENDIF 
 
       IF (offline) THEN
-      call phystoke (
-     I                   nlon,nlev,pdtphys,
-     I                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+
+	 call phystokenc (
+     I                   nlon,nlev,pdtphys,rlon,rlat,
+     I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      I                   ycoefh,yu1,yv1,ftsol,pctsrf,
-     I                   frac_impa, frac_nucl)
+     I                   frac_impa, frac_nucl,
+     I                   pphis,paire,dtime,itap)
+
 
       ENDIF
